// MonPower.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <vector>

#include "Windows.h"
#include "PhysicalMonitorEnumerationAPI.h"
#include "LowLevelMonitorConfigurationAPI.h"

#pragma comment(lib, "dxva2.lib")
#pragma comment(lib, "user32.lib")

//NOTE: NOT ALL MONITORS SUPPORT DDC/CI POWER MANAGEMENT!

//power constants for 0xD6 DDC/CI code
#define POWER_ON                    0x01 
#define POWER_STANDBY               0x02
#define POWER_SUSPEND               0x03
#define POWER_OFF                   0x04

//monitor handles
std::vector<HANDLE> MonHandles;

void AddToMonHandles(HANDLE h)
{
	int i, cnt;
	cnt = MonHandles.size();
	for (i = 0; i < cnt; i++)	
		if (MonHandles[i] == h) return;
	MonHandles.push_back(h);
}

//callback enum func
BOOL CALLBACK EnumProc(
  HMONITOR hMonitor,  // handle to display monitor
  HDC hdcMonitor,     // handle to monitor DC
  LPRECT lprcMonitor, // monitor intersection rectangle
  LPARAM dwData       // data
)
{
	LPPHYSICAL_MONITOR pMons = NULL;
	DWORD i, mcnt;
	if (!GetNumberOfPhysicalMonitorsFromHMONITOR(hMonitor, &mcnt)) return TRUE;
    pMons = (LPPHYSICAL_MONITOR)malloc(mcnt * sizeof(PHYSICAL_MONITOR));
	if (GetPhysicalMonitorsFromHMONITOR(hMonitor, mcnt, pMons))
		for (i = 0; i < mcnt; i++)
			AddToMonHandles(pMons[i].hPhysicalMonitor);
	free(pMons);
	return TRUE;
}

//main proc
int _tmain(int argc, _TCHAR* argv[])
{
	if (argc < 2) return 0;
	bool IsOn = _wcsicmp(argv[1], L"-off") != 0;

	EnumDisplayMonitors(NULL, NULL, EnumProc, NULL);
	int i, cnt;
	cnt = MonHandles.size();
	for (i = 0; i < cnt; i++)
	{
		//two approaches for compatibility, you can disable one of them
		SetVCPFeature(MonHandles[i], 0xD6, IsOn ? POWER_ON : POWER_OFF);
		SetVCPFeature(MonHandles[i], 0xE1, IsOn ? 1 : 0);
	}

	return 0;
}

